  #include <SD.h>

//définition des pins utilisées
/*******************************************************************************************
 * Pour le WEMOS LOLIN32, on peut utiliser le port série qui est sur les broches 16 et 17  *
 * Connexter RX de ECH sur TX de arduino et TX de ECH sur RX de ARDUINO                    *
 * et bien sur les 0v ensembles pour qu'ils aient la même référence                        *
 ******************************************************************************************/
  #define arduino_TX 16                                         //Pin déclarée pour savoir son utilité
  #define arduino_RX 17                                         //Pin déclarée pour savoir son utilité
  
// CARTE sd
  #define sck_sd 18                                             // carte SD sck
  #define miso_sd 19                                            // carte SD MISO
  #define mosi_sd 23                                            // carte SD MOSI
  #define cs_sd 5                                               // carte SD CS
 

int adresse_demandee = 2048; // adresse de lecture des sorties digitales
String demande;
int valeur_demandee = 0;

#define TIMEOUT 1000
 File myFile;

/*******************************************************************************************
 * Pour le WEMOS LOLIN32, on peut utiliser le port série qui est sur les broches 16 et 17  *
 * Connexter RX de ECH sur TX de arduino et TX de ECH sur RX de ARDUINO                    *
 * et bien sur les 0v ensembles pour qu'ils aient la même référence                        *
 ******************************************************************************************/
/*******************************************************************************************
 * adresse pour changer la visibilité D01: 5266 (3) pour visible (258)visible par code     *
 * adresse pour changer la valeur D01: 2194 (0) désactivé (1) activé                       *
 ******************************************************************************************/

void setup() {
  int valeur_lue;
  int s_cool;
  // initialise les ports série:
  Serial.begin(115200);             // pour monitoring des échanges avec l'ordinateur
  Serial2.begin(9600,SERIAL_8E1);   // paramètrage du port série connecté à l'ECH en 9600 bauds, 8 bits, 1 stop, parité paire
  while (!Serial2) {                // attente port série prêt
  }
    SPI.begin(sck_sd,miso_sd,mosi_sd,cs_sd); //démarrage carte SD
    SD.begin(cs_sd);
    if (!SD.begin(cs_sd)) {
      Serial.println("Echec initialisation SD!");
     }
    myFile = SD.open("/param.csv", FILE_WRITE);    
    // if the file opened okay, write to it:
    if (myFile) 
    {
        Serial.print("Efface param.csv...");
        myFile.println("adresse; valeur");
        myFile.close();
    }

  Serial.println("Arduino Ready");

  Serial.println("Début du téléchargement des variables mémoire");
    myFile = SD.open("/param.csv", FILE_APPEND);   // overture du fichier Temp.csv en ajout

  // si le fichier s'ouvre bien alors on écrit dedans :
    if (myFile)
    {
     for (int i=2048; i <= 2207; i++)                                    
       {    
        valeur_lue=lit_valeur(i);                                // Interrogation de la valeur mémmoire setpoint froid
        Serial.print(" adresse : ");
        Serial.print(i);
        Serial.print(" = ");
        Serial.println(valeur_lue);
          
          if (valeur_lue!=9999)                                                   // 
          {      String message = String(i) + ";" + String(valeur_lue) ;
                 myFile.println(message);
           }                                                                              
        }
    }
    myFile.close();

}

void loop() {
   delay (2000);
}
